// LNum.cpp: implementation of the CLNum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LNum.h"
#include "ctype.h"
#include "stdlib.h"
//#include "iostream.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//int r11;
CLNum::CLNum()
{
	cel=new unsigned char[DefCelSize];
	drob=new unsigned char[DefDrobSize];
	cellen=DefCelSize;
	droblen=DefDrobSize;
	sign=1;
	nol=0;
	tochnost=DefTochnost;;
}
CLNum::CLNum(unsigned int CelSize, unsigned int DrobSize, int Ctochnost=10)
{
	cel=new unsigned char[CelSize];
	cellen=CelSize;
	drob=new unsigned char[DrobSize];
	droblen=DrobSize;
//	zposition=0;//   
	sign=1;//  +
	nol=0;
	tochnost=Ctochnost;
}
CLNum::CLNum(long in)
{
	cel=new unsigned char[5];
	cellen=5;
	drob=new unsigned char[0];
	droblen=0;
	long t=abs(in);
	for(char i=0;i<5;i++)// 
	{
		cel[i]=t%100;
		t/=100;
	}
	if(in<0) {sign=-1;}
		else sign=1;
//	drob=new unsigned char;
/*	numbers[0]=LOBYTE(LOWORD(in));
	numbers[1]=HIBYTE(LOWORD(in));
	numbers[2]=LOBYRE(HIWORD(in));
	numbers[3]=HIBYTE(HIWORD(in));
*/
	nol=0;
	tochnost=DefTochnost;
}
CLNum::CLNum(const int in)
{
	cel=new unsigned char[5];
	cellen=5;
	drob=new unsigned char[0];
	droblen=0;
	long t=abs(in);
	for(char i=0;i<5;i++)// 
	{
		cel[i]=t%100;//   -   ,   .
		t/=100;
	}
	if(in<0) {sign=-1;}
		else sign=1;
	
	nol=0;
	tochnost=DefTochnost;
}
CLNum::CLNum(char in)
{
	cel=new unsigned char[2];
	cellen=2;
	drob=new unsigned char[0];
	droblen=0;
	char t=abs(in);
	cel[0]=t%100;
	cel[1]=t/100;
	if (in<0){sign=-1;}
	else sign=1;

	nol=0;
	tochnost=DefTochnost;
}
CLNum::CLNum(char* in)//  ,    - ,   
//       .
//  -   .  "123" : in[0]='23', in[1]='1'.
{
	nol=0;				//       ,      (?)nol,      
	tochnost=DefTochnost;

	
	unsigned int s=strlen(in);
//	unsigned int ExpStrLen;//      
	int ExpN;//  
	char *Epos;
	if((Epos=strchr(in,'E'))==NULL)//  E   (       12E+23)
	{
		Epos=&in[s];
//		ExpStrLen=0;
		ExpN=0;
	}
	else
	{
//		ExpLen=&in[s]-Epos-1;
		ExpN=atoi(Epos+1);
	}
	

		char a,b;
		int tCelLen,tDrobLen;
		char* ZapyatPos=strchr(in,',');
		if(ZapyatPos==NULL) ZapyatPos=strchr(in,'.');
		if(ZapyatPos==NULL) 
		{
			ZapyatPos=Epos;//  ,        
			tDrobLen=0;
		}
		else
		{
			tDrobLen=Epos-ZapyatPos-1;//&in[s]-(ZapyatPos+1)          .   
		}
//		tDrobLen-=ExpN;
		if(in[0]=='-')//     -  , 
		{
			sign=-1;
			tCelLen=ZapyatPos-in-1;
		}
		else
		{
			sign=1;
			tCelLen=ZapyatPos-in;
		}
//		tCelLen+=ExpN;//     - 
//		tDrobLen-=ExpN;
//		if(tCelLen<0)tCelLen=0;
//		if(tDrobLen<0)tDrobLen=0;

		if(tCelLen%2==0)//tCelLen - 
			cellen=tCelLen/2;
		else cellen=tCelLen/2+1;
		cel=new unsigned char[cellen];
		memset(cel,0,cellen);
		if(tDrobLen%2==0)droblen=tDrobLen/2;// tDrobLen 
		else droblen=tDrobLen/2+1;//
	
		drob=new unsigned char[droblen];
		memset(drob,0,droblen);
		//     
		for(long i=0/*   */;i<=tCelLen-2;i+=2)//???
		{
			cel[i/2]=( (a=*(ZapyatPos-i-2)) -48)*10+( (b=*(ZapyatPos-i-1)) -48);//in[i]-48 -     
			if((!isdigit(a))||(!isdigit(b)))
			{
				throw (Error("Non digit symbols in string"));
			}
		}
		if(i==tCelLen-1) 
		{
			cel[i/2]= (a=*(ZapyatPos-tCelLen)) -48;//       .  ,     .    ,      .
			if(!isdigit(a))
			{
				throw (Error("Non digit symbols in string"));
			}
		}

		//    ,   
		if(tDrobLen>0)
		{
			for(long i=0/*   */;i<=tDrobLen-2;i+=2)
			{
				drob[i/2]=( (a=*(ZapyatPos+i+1)) -48)*10+( (b=*(ZapyatPos+i+2)) -48);//in[i]-48 -     
				if((!isdigit(a))||(!isdigit(b)))
				{
					throw (Error("Non digit symbols in string"));
				}
	
			}
			if(i==tDrobLen-1) 
			{
				drob[i/2]= ((a=*(ZapyatPos+tDrobLen)) -48)*10;//       .  ,     .    ,      .
																			//*10    .       
				if(!isdigit(a))
				{
					throw (Error("Non digit symbols in string"));
				}
			}
		}

	//    .
	unsigned char *tmp;
	if(ExpN>0)
	{// 
		tCelLen=2*cellen+ExpN;
		if(tCelLen%2==0)tCelLen/=2;
		else tCelLen=tCelLen/2+1;
		
		tmp=new unsigned char[tCelLen];//,     ,     .
		memcpy(tmp,cel,cellen);
		memset(tmp+cellen,0,tCelLen-cellen);
		delete[] cel;
		cel=tmp;
		cellen=tCelLen;

		operator<<(ExpN/2);
		if(ExpN%2!=0)
			operator*=(CLNum((char)10));
		TrimDrob();
		
	}
	if(ExpN<0)
	{// 
		ExpN=-ExpN;
		tDrobLen=2*droblen+ExpN;
		if(tDrobLen%2==0)tDrobLen/=2;
		else tDrobLen=tDrobLen/2+1;

		tmp=new unsigned char[tDrobLen];//,     ,     .
		memcpy(tmp,drob,droblen);
		memset(tmp+droblen,0,tDrobLen-droblen);
		delete[] drob;
		drob=tmp;
		droblen=tDrobLen;

		operator>>(ExpN/2);
		if(ExpN%2!=0)
			operator*=(CLNum("0.1"));
		TrimCel();
	}



}

CLNum::CLNum(const CLNum& Copy)// 
{
	cellen=Copy.cellen;
	cel=new unsigned char[cellen];
	memcpy(cel,Copy.cel,cellen);

	droblen=Copy.droblen;
	drob=new unsigned char[droblen];
	memcpy(drob,Copy.drob,droblen);
	
	sign=Copy.sign;
	nol=0;
	tochnost=Copy.tochnost;
}
CLNum& CLNum::operator=(const CLNum& Prisv)// 
{
	if(cellen!=Prisv.cellen)
	{
		delete[] cel;//   -  realloc
		cellen=Prisv.cellen;
		cel=new unsigned char[cellen];
	}
	memcpy(cel,Prisv.cel,cellen);

	if(droblen!=Prisv.droblen)
	{
		delete[] drob;//           
		droblen=Prisv.droblen;
		drob=new unsigned char[droblen];
	}
	memcpy(drob,Prisv.drob,droblen);
	sign=Prisv.sign;
	tochnost=Prisv.tochnost;
	return *this;
}


unsigned char& CLNum::operator[](const int index)//  ()  .      .
											     //[0]-     .            .
{
	if(index>=0)
	{
		if(index<cellen)return *(cel+index);//index<cellen,   <=   .
		else return nol;
	}
	else//index<0
	{
		if(-index<=droblen)return *(drob-index-1);//      1 ,    .
		else return nol;
	}
}
bool CLNum::operator==(CLNum& b)
{	bool nenul=false;//,    
	//	if(cellen!=b.cellen) return false;
	//	if(droblen!=b.droblen) return false;  0001   01
		int beg_c,end_c;
		if(cellen<b.cellen)
			beg_c=b.cellen;
		else
			beg_c=cellen;
		if(droblen<b.droblen)
			end_c=b.droblen;
		else
			end_c=droblen;
		for(int i=beg_c;i>=-end_c;i--)
		{
			if(operator[](i)!=b[i]) return false;
			if((!nenul)&&(operator[](i)!=0))nenul=true;
		}
		if((sign!=b.sign)&&(nenul))//    ,     ,    
			return false;
		return true;//       ,   .
}

bool CLNum::operator!=(CLNum& b)
{
	return (!(operator==(b)));
}
	
bool CLNum::operator<(CLNum& b)
{
	bool res=true;
	if(sign==b.sign)
	{
		if(sign==-1)res=false;
		 int beg_c,end_c;
		 if(cellen>b.cellen) beg_c=cellen;
		 else beg_c=b.cellen;

		 if(droblen>b.droblen) end_c=droblen;
		 else end_c=b.droblen;

		 for(int i=beg_c-1;i>=-end_c;i--)//-1     .
		 {
			 if(operator[](i)<b[i])
				 return res;//true;
			 else
				 if(operator[](i)>b[i])return (!res);//false;//    ,   
				 //          ,  ()  operator[]
		 }
		 return false;//  
	}
	else
	{
		if(sign<b.sign)return true;//  .   -0<0
		else return false;
	}
}

bool CLNum::operator<=(CLNum& b)
{
	bool res=true;
	if(sign==b.sign)
	{
		if(sign==-1)res=false;
		 int beg_c,end_c;
		 if(cellen>b.cellen) beg_c=cellen;
		 else beg_c=b.cellen;

		 if(droblen>b.droblen) end_c=droblen;
		 else end_c=b.droblen;

		 for(int i=beg_c-1;i>=-end_c;i--)//-1     .
		 {
			 if(operator[](i)<b[i])return res;//true;
			 else
				 if(operator[](i)>b[i])return (!res);//false;//    ,   
				 //          ,  ()  operator[]
		 }
		 return true;//  
	}
	else
	{
		if(sign<b.sign)return true;//  .   -0<0
		else return false;
	}
}


bool CLNum::operator>(CLNum& b)
{
	bool res=true;;
	if(sign==b.sign)
	{
		if(sign==-1)res=false;
		 int beg_c,end_c;
		 if(cellen>b.cellen) beg_c=cellen;// 
		 else beg_c=b.cellen;

		 if(droblen>b.droblen) end_c=droblen;// 
		 else end_c=b.droblen;

		 for(int i=beg_c-1;i>=-end_c;i--)//-1     .
		 {
			 if(operator[](i)>b[i])return res;//true;//i-    i-   ,     . 
											  //    ,   ,   ,   .            res
			 else
				 if(operator[](i)<b[i])return (!res);//false;//    ,   
				 //          ,  ()  operator[]
		 }
		 return false;// 
	}
	else
	{
		if(sign>b.sign)return true;//  .   -0<0
		else return false;//sign<b.sign
	}
	
}
bool CLNum::operator>=(CLNum& b)
{
	bool res=true;
	if(sign==b.sign)
	{
		if(sign==-1)res=false;//    ,      .
		 int beg_c,end_c;
		 if(cellen>b.cellen) beg_c=cellen;
		 else beg_c=b.cellen;

		 if(droblen>b.droblen) end_c=droblen;
		 else end_c=b.droblen;

		 for(int i=beg_c-1;i>=-end_c;i--)//-1     .       ,      (      res)
		 {								 //,      ,  .
			 if(operator[](i)>b[i])return res;//true;
			 else
				 if(operator[](i)<b[i])return (!res);//false;//    ,   
				 //          ,  ()  operator[]
		 }
		 return true;//  
	}
	else
	{
		if(sign<b.sign)return true;//  .   -0<0
		else return false;
	}
}


CLNum CLNum::operator-()//  
{
	
	CLNum tmp(*this);
	tmp.sign=-tmp.sign;
	return tmp;
}

CLNum& CLNum::operator+=(CLNum& b)
{
	//!!!   ,     .
if(sign==b.sign)
{
	// ,     

	//    . ( )
	int min1;

	unsigned char *tmp;
	if(droblen<b.droblen)//    
	{
		min1=droblen;

		tmp=new unsigned char[droblen];//    
		memcpy(tmp,drob,droblen);
		delete[] drob;
		drob=new unsigned char[b.droblen];//     
		memset(drob,0,b.droblen);
		memcpy(drob,tmp,droblen);//       
		droblen=b.droblen;//     .
		delete[] tmp;
	}
	else min1=b.droblen;

	int m,max1;
	if(b.cellen>cellen)
	{
		m=b.cellen;//   .
		max1=cellen;//   
	}
	else
	{
		m=cellen;
		max1=b.cellen;
	}

	//         1.
	tmp=new unsigned char[cellen];
	memcpy(tmp,cel,cellen);
	delete[] cel;
	cel=new unsigned char[m+1];//+1         98+3=101.
	memset(cel,0,m+1);
	memcpy(cel,tmp,cellen);
	delete[] tmp;
	cellen=m+1;//     
	//,       ,     
//	min1=-min1;//   

	unsigned char perenos=0;
	unsigned char atmp=0;
	// .    .

	int i;
	// ,    .
	for(i=b.droblen-1;i>=min1/*>min1-1*/;i--)//   b    a
		drob[i]=b.drob[i];
	// ,     .
	for(i=min1-1;i>=0;i--)
	{
		atmp=drob[i]+b.drob[i]+perenos;
		drob[i]=atmp%100;
		perenos=atmp/100;
	}


	//  operator[]
	//      . 
	//   ,     .
	for(i=0;(i<max1)||perenos!=0;i++)//  -     ,   operator[](max1)  cellen- -  ,     -,       .
										 // max1 ,     ,    ,  perenos   
	{
		atmp=operator[](i)+b[i]+perenos;
		cel[i]=atmp%100;
		perenos=atmp/100;
	}
	for(i;i<b.cellen;i++)
		cel[i]=b.cel[i];

	
	return *this;
}//if sign==b.sign
else
	return operator-=(-b);
/*
        operator-=,      .
   b - .
(-a)+b=(-a)-(-b);
a+(-b)=a-b        operator-=(!-!b)
*/
}//end operator+=;

CLNum& CLNum::operator -=(CLNum& b)
{
	if(operator==(b)) return (*this=CLNum(char(0)));
if(sign==b.sign)
{
	unsigned char *tmp;
	int min1,max1;
	if(droblen<b.droblen)
	{
		min1=b.droblen;
		//      ,    .
		
		tmp=new unsigned char[droblen];//    
		memcpy(tmp,drob,droblen);
		delete[] drob;
		drob=new unsigned char[min1];//     
		memset(drob,0,min1);
		memcpy(drob,tmp,droblen);//       
		droblen=b.droblen;//     .
		delete[] tmp;

	}
	else min1=droblen;//     
	if(cellen<b.cellen) 
	{
		max1=b.cellen;

		//      ,    .
		tmp=new unsigned char[cellen];
		memcpy(tmp,cel,cellen);
		delete[] cel;
		cel=new unsigned char[max1];
		memset(cel,0,max1);
		memcpy(cel,tmp,cellen);
		delete[] tmp;
		cellen=max1;//     
	}
	else max1=cellen;
	//  -.

	//  .
	unsigned char perenos=0;
	if((operator>(b)&&sign==1)||(operator<(b)&&sign==-1))//abs(*this)>abs(b)    
	{
		// *this  b
		for(int i=-min1;i<max1;i++)//  i<max1  b[max1-1]     b.  - b  .   *this.
		{
			if(operator[](i)<b[i]+perenos)
			{
				operator[](i)=operator[](i)+100-b[i]-perenos;
				perenos=1;
			}
			else
			{
				operator[](i)=operator[](i)-b[i]-perenos;
				perenos=0;
			
			}
		}
		/*  -.
		for(int i=min1;i<max1;i++)
		{
			t=operator[](i)+100-b[i]+perenos;
			operator[](i)=t%100;
			perenos=t/100;
		}
		       ,   .
		*/

	}//if(*this>b)
	else//   .  b  *this
	{
		sign=-sign;
		for(int i=-min1;i<max1;i++)//  i<max1  b[max1-1]     b.  - b  .   *this.
		{
			if(b[i]<operator[](i)+perenos)
			{
				operator[](i)=b[i]+100-operator[](i)-perenos;
				perenos=1;
			}
			else
			{
				operator[](i)=b[i]-operator[](i)-perenos;
				perenos=0;
			
			}
		}

	}
	return *this;
}//if(dign==b.sign)
else
	return operator+=(-b);
/*
	   operator+=.
	a-(-b)=a+b;
	(-a)-b=(-a)+(-b).
	 (-)  (-b) -    (   ?).
*/
}

CLNum& CLNum::operator*=(CLNum& b)
{

		unsigned int i,j;
		unsigned int Alen=cellen+droblen;
		unsigned int Blen=b.cellen+b.droblen;
		unsigned char *x=new unsigned char[Alen+1];//+  
		unsigned char *y=new unsigned char[Blen+1];
		unsigned char *sum=new unsigned char[Alen+Blen+2];
		
		for(i=0;i<droblen;i++)
			x[i]=drob[droblen-i-1];
		memcpy(x+droblen,cel,cellen);
	
		for(i=0;i<b.droblen;i++)
			y[i]=b.drob[b.droblen-i-1];
		memcpy(y+b.droblen,b.cel,b.cellen);

		memset(sum,0,Alen+Blen);
	//    .   .
		unsigned char perenos,perenosplus;
		unsigned short r,r1;
		//       
		for(i=0;i<Blen;i++)
		{
			perenos=0;
			perenosplus=0;
			if(y[i]!=0)//     
			{
				for(j=0;j<Alen;j++)
				{
					r=x[j]*y[i]+perenos;// 
					perenos=r/100;
					r=r%100;
					
					r1=r+sum[i+j]+perenosplus;//  
					perenosplus=r1/100;
					sum[i+j]=r1%100;
				}
				perenosplus+=perenos;// ,     ,      .
				while(perenosplus!=0)
				{
					r1=sum[i+j]+perenosplus;
					sum[i+j]=r1%100;
					perenosplus=r1/100;
					j++;
				}
			}
		}
		delete[] x;
		delete[] y;
		// .     
		//     ,    .
		
		unsigned int m=cellen+b.cellen;
		delete[] cel;
		cel=new unsigned char[m];
		memset(cel,0,m);

		
		cellen=m;//     

		m=droblen+b.droblen;
		delete[] drob;
		drob=new unsigned char[m];//     
		memset(drob,0,m);//  ,    
		droblen=m;

		
		for(i=0;i<m;i++)//     
			drob[i]=sum[m-i-1];
		memcpy(cel,sum+m,cellen/* =cellen(old)+b.cellen*/);
	

	
		if(sign==b.sign) sign=1;
		else sign=-1;
	return *this;
}

CLNum& CLNum::operator<<(const int count)
{
	for(int i=cellen-1;i>=-droblen;i--)
		operator[](i)=operator[](i-count);//,     .   .
	return *this;	
}
CLNum& CLNum::operator>>(const int count)
{
	for(int i=-droblen;i<cellen;i++)
		operator[](i)=operator[](i+count);//,     .   .
	return *this;	
}

CLNum& CLNum::operator/=(CLNum& b)
{
	if(b==(CLNum)(char)0)throw(DivZero());
	if(operator==((CLNum)(char)0)) return *this;//     ,  

	int i,end_loop,cur_usl=0;  //cur_usl    . ,     
	unsigned char *otv=new unsigned char[b.droblen+cellen+1+tochnost];// len   ,      tmp    - 

	b.TrimCel();
	TrimCel();//  
	b.TrimDrob();
	TrimDrob();
	unsigned int len=b.cellen+b.droblen;
	end_loop=cellen+b.droblen+1+tochnost;// len   ,      tmp    - 
	unsigned int cur_otv=0;
	CLNum tmp(len+1,0);
	memset(tmp.cel,0,len+1);
	CLNum delitel(len,0);//     123.44->1,23,44
	memset(delitel.cel,0,len);

	// 
	for(i=0;i<len;i++)
		delitel.cel[i]=b[-b.droblen+i];
	delitel.TrimCel();
	delitel.TrimDrob();
	len=delitel.cellen+delitel.droblen;
		//b.cel[b.cellen-1-i];//    
//	memcpy(delitel.cel+b.cellen,b.drob,b.droblen);//       .

	//  -   
	int res_cellen=-1;//       .-1 -   
	unsigned char k;
	unsigned int f;
//	CLNum tt(tmp);

	for(i=0;i<len;i++)// () len     tmp
		tmp.cel[i]=operator[](cellen-len+i);//    . 
//	tmp.TrimCel();
//	tmp.TrimDrob();

	cur_usl=cellen-1/**/-len;
	bool flag=false;//,   len     len  
	while(tmp<delitel)//  ,   *this   
	{
		tmp<<1;
		tmp.cel[0]=operator[](cur_usl);
		cur_usl--;
//		flag=true;
	}
	
	if((cur_usl<-1)&&(!flag)) 
	{
		res_cellen=cur_usl+2;//<-1   5      5 ,  i=6  cur_usl=-1.      
		flag=true;	
	}
	//  
	
	while(cur_otv<end_loop)
	{
		if(tmp.cellen>1)//        k      .        tmp=len    len,  tmp>delitel. 
		{
			f=tmp.cel[len]*100+tmp.cel[len-1];// ,         .     tmp.cel[len]   ,     .
		}
		else
			f=tmp.cel[0];//  tmp.cel[len-1] len=1
		k=f/(delitel.cel[len-1]+1);//    
		//k -   .    (  |  tmp())mod(  +1)
		
		//,    k delitel*k<tmp    k. ( tmp)>=(( )*k)
		//  k  delitel*k<tmp  delitel*(k+1)>tmp
//		bool bf;
		while(delitel*(CLNum)(char)(k+10)<=tmp) 
			k+=10;
		// k  .    1.
		while(delitel*(CLNum)(char)(k+1)<=tmp) 
			k++;

		//  k,    
		tmp-=delitel*(CLNum)(char)k;
		
		do
		{
			otv[cur_otv]=k;
			cur_otv++;
			tmp<<1;//     ,   tmp     .  .      
			tmp.cel[0]=operator[](cur_usl);
			cur_usl--;
			if((cur_usl<-1)&&(!flag)) 
			{
				res_cellen=cur_otv;//cur_usl<-1 .cur_otv,  cur_otv    .   .      .
				flag=true;			
			}
			k=0;
		}
		while((tmp<delitel)&&(cur_otv<end_loop));
		//  .  tmp   ,  delitel'
	
	}//end while(cur_otv<end_loop
	if(!flag)
		res_cellen=cur_otv;
	droblen=tochnost;//-b.droblen
	delete[] cel;
	delete[] drob;

	drob=new unsigned char[droblen];
	memset(drob,0,droblen);
	cellen=res_cellen+b.droblen;
	if(cellen<0)
	{//     .  ,         otv    (abs(cellen))  ,   drob ,   drob+abs(cellen)  otv
		cel=new unsigned char[0];
	//	memset(drob,0,droblen);
		cellen=-cellen;
		memcpy(drob+cellen,otv,droblen-cellen);

		cellen=0;
	}
	else
	{
		cel=new unsigned char[cellen];
	//	memset(drob,0,droblen);
		for(i=0;i<cellen;i++)
			cel[i]=otv[cellen-i-1];

	
		memcpy(drob,otv+cellen,droblen);
	}
	delete[] otv;
	if(sign==b.sign)sign=1;
	else sign=-1;

	return *this;
}

void CLNum::TrimCel() //   .  ,   
{
	int i=0;// ,   
	while(cel[cellen-1-i]==0)i++;
	if(i!=0)
	{// 
		unsigned char *tmp=new unsigned char[cellen-i];
		memcpy(tmp,cel,cellen-i);
		delete[] cel;
		cel=tmp;
		cellen=cellen-i;
	}
}
void CLNum::TrimDrob()//   .
{
	int i=0;// ,   
	while(drob[droblen-1-i]==0)i++;
	if(i!=0)
	{// 
		unsigned char *tmp=new unsigned char[droblen-i];
		memcpy(tmp,drob,droblen-i);
		delete[] drob;
		drob=tmp;
		droblen=droblen-i;
	}

}

int CLNum::GetTochnost()
{
	return tochnost;
}
void CLNum::SetTochnost(const int a)
{
	tochnost=a;
}
void CLNum::SetVal(char* in)
{
	CLNum tmp(in);
	operator=(tmp);
}
void CLNum::SetVal(const int in)
{
	delete[] cel;
	delete[] drob;
	cel=new unsigned char[5];
	cellen=5;
	drob=new unsigned char[0];
	droblen=0;
	long t=abs(in);
	for(char i=0;i<5;i++)// 
	{
		cel[i]=t%100;//   -   ,   .
		t/=100;
	}
	if(in<0) {sign=-1;}
		else sign=1;

	tochnost=DefTochnost;
}
CLNum::~CLNum()
{
	delete[] cel;
	delete[] drob;
}
ostream& operator<<(ostream& s, CLNum& a)
	{
		CLNum tmp(a);
		tmp.TrimCel();
		tmp.TrimDrob();
		if(tmp.sign==-1) s<<"-";
		int i;
		if(tmp.cellen==0) s<<"0";
		for(i=tmp.cellen-1;i>=0;i--)
			s<<char(tmp.cel[i]/10+48)<<char(tmp.cel[i]%10+48);
		if(tmp.droblen>0)
		{
			s<<".";
			for(i=1;i<=tmp.droblen;i++)
			s<<char(tmp.drob[i-1]/10+48)<<char(tmp.drob[i-1]%10+48);
		}
		return s;
	}
CLNum operator+(CLNum& a, CLNum& b)
{
	CLNum tmp(a);
	tmp+=b;
	return tmp;
}
CLNum operator-(CLNum& a, CLNum& b)
{
	CLNum tmp(a);
	tmp-=b;
	return tmp;
}
CLNum operator+(const int a, CLNum& b)
{
	CLNum tmp(a);
	tmp+=b;
	return tmp;
}

CLNum operator*(CLNum& a, CLNum& b)
{
	CLNum tmp(a);
	tmp*=b;
	return tmp;
}

CLNum operator/(CLNum& a, CLNum& b)
{
	CLNum tmp(a);
	tmp/=b;
	return tmp;
}
CLNum operator*(const int a, CLNum& b)
{
	CLNum tmp(a);
	tmp*=b;
	return tmp;
}

CLNum sqrt(CLNum& x)
{
	int counter=0,i;
	bool inverted=false;

	CLNum nolik("0");
	CLNum c16((char)16);
	CLNum c05("0.5");
	CLNum c4((char)4);
	CLNum a(x);
	if(a<nolik) 
		throw(CLNum::Error("MathError: Value that is less than zero is under sqr"));
	if(a==nolik)return a;//  .
	/* argument less than 1 : invert it */
	if(a<(CLNum((char)1))) 
	{
		a=((CLNum)(char)1)/a;
		inverted=true;
	}
	
	/* process series of division by 16 until argument is <16 */
	while(a>c16) 
	{
		counter++;
		a/=c16;
	}
	/* initial approximation */
	CLNum p1((char)2);
	CLNum p2(1,0);
	/* Newtonian algorithm */
	for(i=ITNUM;i>0;i--) 
	{
//		cout<<"p2="<<p2<<"  p1="<<p1<<"  a="<<a<<"\n";
//	    cin>>r11;
		p2=a/p1; 
//		cout<<"p2="<<p2<<"\n";
//		cin>>r11;
		p1+=p2; 
//		cout<<"p1="<<p1<<"\n";
//		cin>>r11;
		p1*=c05;
	}
	/* multiply result by 4 : as much times as divisions by 16 took place */
	while(counter>0) 
	{
		counter--;
		p1*=c4;
	}
	/* invert result for inverted argument */
	if(inverted) p1=((CLNum)(char)1)/p1;
	return(p1);

}