// LNum.h: interface for the CLNum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LNUM_H__6C7DF4A7_515D_11D5_AC10_EBC1DD062A0B__INCLUDED_)
#define AFX_LNUM_H__6C7DF4A7_515D_11D5_AC10_EBC1DD062A0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "string.h"
#include "iostream.h"

#define DefCelSize  10
#define DefDrobSize 10
#define DefTochnost 10
#define ITNUM 8
class CLNum  
{
friend 	ostream& operator<<(ostream& s,CLNum& a);
friend CLNum sqrt(CLNum& a);
//friend CLNum operator+(CLNum& a, CLNum& b);
//friend CLNum operator-(CLNum& a, CLNum& b);
public:
	CLNum();// ;
	CLNum(unsigned int ,unsigned int,int);//   
	CLNum(long);//      long
	CLNum(char in);
	CLNum(char* in);
	CLNum(const int);
	CLNum& operator=(const CLNum&);
	CLNum(const CLNum& Copy);
	virtual ~CLNum();
	struct Error// ,      ,       "1232".
	{
		const char* p;
		Error(const char* q){p=q;}
	};
	struct DivZero//  
	{
	};
	//

	unsigned char& operator[](const int index);//  ()  .      .
											   //[0]-     
	bool operator==(CLNum& b);
	bool operator!=(CLNum& b);
	bool operator<(CLNum& b);
	bool operator<=(CLNum &b);
	bool operator>(CLNum& b);
	bool operator>=(CLNum& b);
	CLNum operator-();//  
	CLNum& operator<<(const int count);//   count 
	CLNum& operator>>(const int count);//   count 
	CLNum& operator+=(CLNum& b);
	CLNum& operator-=(CLNum& b);
	CLNum& operator*=(CLNum& b);
	CLNum& operator/=(CLNum& b);
	void TrimCel(); //   .  ,   
	void TrimDrob();//   .
	int GetTochnost();
	void SetTochnost(const int a);
	int GetCellen(){return cellen;}
	int GetDroblen(){return droblen;}
	char GetSign(){return sign;}
	void SetVal(char* in);
	void SetVal(const int in);
private:
	unsigned char *cel;//  
	unsigned char *drob;// 
	/*unsigned*/ int cellen;//     
	/*unsigned*/ int droblen;//  
//	int zposition;// 
	char sign;// 
	unsigned char nol;//      op[]       .
	int tochnost;
};
ostream& operator<<(ostream& s,const CLNum& a);
CLNum operator+(CLNum& a, CLNum& b);
CLNum operator-(CLNum& a, CLNum& b);
CLNum operator+(const int a, CLNum& b);
CLNum operator*(CLNum& a, CLNum& b);
CLNum operator/(CLNum& a, CLNum& b); 
CLNum operator*(const int a,CLNum& b);
//CLNum sqrt(CLNum& a);
#endif // !defined(AFX_LNUM_H__6C7DF4A7_515D_11D5_AC10_EBC1DD062A0B__INCLUDED_)
